// AliBaba.H
// Base class for mode definitions

#ifndef _AliBaba_H_
#define _AliBaba_H_

#include "GlutApp.H"


namespace CS148 {

using namespace std;

class FPSView;
class Animator;
class Animated;
class Mover;
class Camera;
class Carpet;
class Ground;
class Cave;
class TargetReticle;
class CocoBomb;
class Rider;
class ScoreView;
class Radar;
class PauseView;


class AliBaba : public GlutApp, public Functor
{
public:
  static GlutApp* factory () { return new AliBaba; }

  AliBaba ();
  ~AliBaba ();

  // ------------------------------------------------------------
  // Event handlers

  void processArgs ( int& argc, char** argv );
  void init ();
  void reshape ( int, int );
  void display ();

  void func ();

  void keyboard ( const KeyEvent& );
  void button ( const ButtonEvent& );
  void motion ( const MotionEvent& );


  // building the world
  void buildWorld ();
  void placeRider ( Real boundary );


  // Playing...
  void addMover ( Mover* mv );
  void removeMover ( Mover* mv );
  void addAnim ( Animated* anim );
  void removeAnim ( Animated* anim );

  void animate ( Real interval );

  void launchBomb ( int x, int y );
  void exploded ( CocoBomb* cb );

  void killed ( Rider* rd );
  void reachedCave ( Rider* rd );
  void removeRider ( Rider* rd );


private:

  bool slowMode;

  FPSView* fpsView;
  Animator* anim;
  Ground* ground;
  Cave* cave;
  Carpet* carpet;
  Camera* camera;
  TargetReticle* reticle;
  ScoreView* score;
  Radar* radar;
  PauseView* pauseView;

  vector<Mover*> movers;
  vector<Animated*> anims;
  vector<Rider*> riders;
};



} // namespace CS148

#endif /* _AliBaba_H_ */





