// Animated.C

#include "Animated.H"

namespace CS148 {


Animated::Animated ()
  : frames(), frame(0), frameSpeed(0), frameDelay(0), frameAccum(0)
{

}


Animated::~Animated ()
{
}


void Animated::advanceFrame ( Real interval )
{
  frameAccum += interval;

  if ( frameDelay ) 
    while ( frameAccum > frameDelay ) {
      nextFrame();
      frameAccum -= frameDelay;
    }
}


void Animated::nextFrame ()
{
  ++frame;
  if ( frame >= frames.size() ) {
    frame = 0;
    endAnimSequence();
  }
}


void Animated::endAnimSequence ()
{


}


void Animated::setFrameSpeed ( Real sp )
{
  frameSpeed = sp; // frames per second
  frameDelay = 1.0 / frameSpeed; // interval between frames
}


void Animated::addFrame ( DisplayList* dl )
{
  frames.push_back ( dl );
}


void Animated::deleteFrames ()
{
  for ( vector<DisplayList*>::iterator iter = frames.begin();
	iter != frames.end(); ++iter )
    delete *iter;
  frames.clear();
}


void Animated::renderCurrFrame ()
{
  if ( frame < frames.size() )
    frames[frame]->call();
}


} // namespace CS148
