// Animated.H

#ifndef _Animated_H_
#define _Animated_H_

#include "GlutApp.H"

namespace CS148 {

class Ground;
class Turn;

class Animated
{
public:
  Animated ();
  virtual ~Animated ();

  virtual void buildFrames() = 0;
  void addFrame ( DisplayList* dl );
  void deleteFrames ();

  void advanceFrame ( Real interval );
  void renderCurrFrame ();

  void setFrameSpeed ( Real sp );
  Real getFrameSpeed () const { return frameSpeed; }
  void setFrame ( unsigned int i ) { frame = i%frames.size(); }
  void nextFrame ();

protected:

  virtual void endAnimSequence ();

private:

  vector<DisplayList*> frames;
  unsigned int frame;
  Real frameSpeed, frameDelay, frameAccum;
};



} // namespace CS148


#endif /* _Animated_H_ */

