// Carpet.H

#ifndef _Carpet_H_
#define _Carpet_H_

#include "Mover.H"
#include "Animated.H"

namespace CS148 {

class Ground;


class Carpet : public Mover, public Animated
{
public:
  Carpet ( Ground* gr, bool slowMode );
  ~Carpet ();

  void buildFrames ();
  void render ( Viewport* vp );

  void key ( const KeyEvent& ev );
  void move ( Real interval );

private:


  void adjustHeight();
  void turnLeft();
  void turnRight();
  void accelerate();
  void decelerate();

  bool slowMode;
  bool goingLeft, goingRight, goingFaster, goingSlower;

};




} // namespace CS148


#endif /* _Carpet_H_ */

