// Cave.H

#ifndef _Cave_H_
#define _Cave_H_

#include "Mover.H"

namespace CS148 {

class AliBaba;
class Ground;
class Light;

class Cave : public Mover, public Functor
{
public:
  Cave ( AliBaba* app, Ground* ground, bool slowMode );
  ~Cave ();

  void render ( Viewport* vp );
  void move ( Real interval );
  void openSesame ();
  void func ();


private:

  AliBaba* app;
  Ground* ground;
  
  enum State { closed, closing, opened, opening };
  State state;
  Real minHeight, maxHeight, targetHeight;
  DisplayList* dlist;
  
  Light *l1, *l2, *l3;
};


} // namespace CS148


#endif /* _Cave_H_ */

