// FPSView.H

#ifndef _FPSView_H_
#define _FPSView_H_

#include "GlutApp.H"


namespace CS148 {


class FPSView : public Viewport, public Functor
{
public:
  FPSView () 
    : Viewport( 0, 0, 100, 20 ), currFPS(0), fpsStr()
  {
    fpsStr[0] = '\0';
    setOrtho ( 0, 100, 0, 20 );
  }

  ~FPSView () {}

  void render () {
    glPushAttrib ( GL_ENABLE_BIT );
    glDisable(GL_LIGHTING);
    glColor3fv ( Color::GREEN() );
    glPushMatrix();
    glLoadIdentity();
    
    renderBitmapString ( 3, 3, fpsStr );

    glPopMatrix();
    glPopAttrib ();
  }


  void func ()
  {
    GlutApp* app = GlutApp::getInstance();
    if ( app ) {
      currFPS = app->measureFrameRate();
      sprintf ( fpsStr, "%.1f fps", currFPS );
      app->after ( 1000, this );
    }
  }


private:

  float currFPS;
  char fpsStr[15];
  

};


} // namespace CS148

#endif /* _FPSView_H_ */
