// Fog.H

#ifndef _Fog_H_
#define _Fog_H_

#include "GlutApp.H"

namespace CS148 {

class Fog : public DisplayBuilder
{
public:
  Fog ( GLenum mode, const Color& col,
	GLfloat dens, GLfloat near = 0.0, GLfloat far = 1.0 )
    : DisplayBuilder(),
      mode(mode), color(col), density(dens), near(near), far(far)
  {
    glEnable ( GL_FOG );
  }

  ~Fog () {}

  void draw () { buildDisplayList(); }

private:

  void buildDisplayList () {
    glFogi ( GL_FOG_MODE, mode );
    glFogfv ( GL_FOG_COLOR, color );
    glFogf ( GL_FOG_DENSITY, density );
    if ( mode == GL_LINEAR ) {
      glFogf ( GL_FOG_START, near );
      glFogf ( GL_FOG_END, far );
    }
  }

  GLenum mode;
  Color color;
  GLfloat density, near, far;
};



} // namespace CS148


#endif /* _Fog_H_ */

