// Radar.C

#include "Radar.H"

#include "Carpet.H"
#include "Rider.H"


namespace CS148 {


void Radar::render ()
{
//   int x, y, w, h; getArea ( x, y, w, h );

  glPushAttrib ( GL_ENABLE_BIT | GL_COLOR_BUFFER_BIT );
  glDisable(GL_LIGHTING);

  glEnable ( GL_BLEND );
  glBlendFunc ( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );

  glPushMatrix();
  glLoadIdentity();

  
  glColor4f ( 0, .2, 0, .4 );
  if ( !disk ) disk = gluNewQuadric();
  glPolygonMode ( GL_FRONT_AND_BACK, GL_FILL );
  glPushMatrix ();
  glTranslatef ( 0, 0, -.25 );
  gluDisk ( disk, 0, 1.0, 16, 1 );
  glPopMatrix();

  glPointSize ( 2.0 );
  glColor3f ( 1, 0, 0 );
  glBegin ( GL_POINTS );
  for ( vector<Rider*>::iterator iter = riders.begin();
	iter != riders.end(); ++iter ) {
    Rider* rd = *iter;

    Vec3 v = rd->getPos() - carpet->getPos();
    v *= 1/150.0;
    if ( len(v) > 1.0 ) v.Normalise();

    glVertex2f ( -v[0], v[2] );
  }
  glEnd();

  glRotatef ( 180 - carpet->getRotation(), 0, 0, 1 );

  glLineWidth ( 1.0 );
  glColor3f ( 1, 1, 1 );
  glBegin ( GL_LINES );
  glVertex2f ( 0, 0 );
  glVertex2f ( .866, .5 );
  glVertex2f ( 0, 0 );
  glVertex2f ( .866, -.5 );
  glEnd();

  
  glPopMatrix();
  glPopAttrib();
}


} // namespace CS148
