// Rider.H

#ifndef _Rider_H_
#define _Rider_H_

#include "Mover.H"
#include "Animated.H"

namespace CS148 {

class AliBaba;
class Ground;
 class Cave;

class Rider : public Mover, public Animated, public Functor
{
public:
  Rider ( AliBaba* app, Ground* ground, Cave* cave );
  ~Rider ();

  void buildFrames ();
  void render ( Viewport* vp );
  void move ( Real interval );

  void nearMiss ();
  void hitByBomb ();

  void func ();

private:

  bool plan ();

  AliBaba* app;
  Ground* ground;
  Cave* cave;

  Vec3 goal;
  bool nearGoal;
};


} // namespace CS148


#endif /* _Rider_H_ */

