// ScoreView.H

#ifndef _ScoreView_H_
#define _ScoreView_H_

#include "GlutApp.H"


namespace CS148 {


class ScoreView : public Viewport
{
public:
  ScoreView ( int x, int y, int w, int h )
    : Viewport( x, y, w, h ), riders(0), escaped(0), killed(0), str()
  {
    str[0] = '\0';
  }

  ~ScoreView () {}

  void reshaped ( int x, int y, int w, int h ) {
    Viewport::reshaped ( x, y, w, h );
    setOrtho ( x, x+w, y, y+h );
  }
    
  void render () {
    glPushAttrib ( GL_ENABLE_BIT );
    glDisable(GL_LIGHTING);
    glColor3fv ( Color::BLUE() );
    glPushMatrix();
    glLoadIdentity();

    int x, y, w, h; getArea ( x, y, w, h );
    renderBitmapString ( x+3, y+h-15, str, GLUT_BITMAP_HELVETICA_12  );

    glPopMatrix();
    glPopAttrib();
  }


  void addedRider () { riders++; updateStr(); }
  void killedRider () { riders--; killed++; updateStr(); }
  void escapedRider () { riders--; escaped++; updateStr(); }

private:

  void updateStr ()
  {
    sprintf ( str, "%d thieves / %d killed / %d escaped",
	      riders, killed, escaped );
  }

  int riders, escaped, killed;
  char str[100];
  

};


} // namespace CS148

#endif /* _ScoreView_H_ */
