// CS148

#include "TargetReticle.H"


namespace CS148 {

class ReticleBuilder : public DisplayBuilder
{
public:
  ReticleBuilder() : DisplayBuilder() {}
  ~ReticleBuilder() {}

  void buildDisplayList () {
    glPushAttrib ( GL_ENABLE_BIT );
    glDisable(GL_LIGHTING);
    glColor3fv ( Color::BLUE() );

    static const GLint sp = 6;
    static const GLint trib = 6;
    static const GLint trih = 12;
    
    glPolygonMode ( GL_FRONT_AND_BACK, GL_LINE );
    glLineWidth ( 1.0 );
    glBegin ( GL_TRIANGLES );
    {
      // Left
      glVertex2i ( -sp, 0 );
      glVertex2i ( -sp - trih, trib );
      glVertex2i ( -sp - trih, -trib );
      
      // Right
      glVertex2i ( sp + trih, -trib );
      glVertex2i ( sp + trih, trib );
      glVertex2i ( sp, 0 );
    }
    glEnd();
    glPopAttrib();
  }

};



TargetReticle::TargetReticle ( int x, int y, int w, int h )
  : Viewport ( x, y, w, h ), dlist(0)
{
  dlist = ReticleBuilder().buildNew( true );
}


TargetReticle::~TargetReticle ()
{
  delete dlist;
}


void TargetReticle::reshaped ( int x, int y, int w, int h )
{
  Viewport::reshaped ( x, y, w, h );
  setOrtho ( x, x+w, y, y+h );
}

void TargetReticle::motion ( const MotionEvent& ev )
{
  setPos ( Vec3( ev.x, ev.y, 0 ) );
}


void TargetReticle::render ()
{
  glPushMatrix();
  glLoadIdentity();
  translate();
  dlist->call();
  glPopMatrix();
}



} // namespace CS148
