// Texture.C

#include "Texture.H"

namespace CS148 {


GLuint Texture::boundTex = NO_TEX;


Texture::Texture ( bool twoD )
  : texId(0), texDim(twoD? GL_TEXTURE_2D : GL_TEXTURE_1D)
{
  glGenTextures ( 1, &texId );

  bind();
  init();
}


Texture::~Texture ()
{
  glDeleteTextures ( 1, &texId );
}


void Texture::bind ()
{
  // In order to work in a DisplayList, have to do bind / unbind
  // every time
//   if ( boundTex != texId ) {
    glEnable ( texDim );
    glBindTexture ( texDim, texId );
    boundTex = texId;
//   }
}


void Texture::unbind ()
{
//   if ( boundTex == texId ) {
    glDisable ( texDim );
    boundTex = NO_TEX;
//   }
}


void Texture::init ()
{
  bind();
  setModulatedMipmap ();
}






} // namesapce CS148
